#include <stdio.h>
#include <windows.h>

int openSerialPort(char *dev_name)
{
  HANDLE fh;
  DCB fdcb;
  COMMTIMEOUTS fcommtimeouts;

  fh = CreateFile(dev_name,
                  GENERIC_READ | GENERIC_WRITE,
                  0, NULL, OPEN_ALWAYS,
                  FILE_ATTRIBUTE_NORMAL, NULL);
  if (!fh) {
    return -1;
  }
  GetCommState(fh, &fdcb);
  fdcb.BaudRate = CBR_9600;
  fdcb.ByteSize = 8;
  fdcb.StopBits = ONESTOPBIT;
  fdcb.Parity = NOPARITY;
  SetCommState(fh, &fdcb);

  GetCommTimeouts(fh, &fcommtimeouts);
  fcommtimeouts.ReadIntervalTimeout = MAXDWORD;
  fcommtimeouts.ReadTotalTimeoutMultiplier = 0;
  fcommtimeouts.ReadTotalTimeoutConstant = 0;
  SetCommTimeouts(fh, &fcommtimeouts);

  return (int)fh;
}

int closeSerialPort(int fh)
{
  if (fh != 0) {
    CloseHandle((HANDLE)fh);
  }
  return 0;
}

int readSerialPortInto(int fh, int count, char *startPtr)
{
  DWORD bytesRead = 0;
  void *buffer = (void *)startPtr;

  
  ReadFile((HANDLE)fh, buffer, count, &bytesRead, NULL);
  return (int)bytesRead;
}

int writeSerialPortFrom(int fh, int count, char *startPtr)
{
  DWORD bytesWritten;
  void *buffer = (void *)startPtr;

  WriteFile((HANDLE)fh, buffer, count, &bytesWritten, NULL);
  return (int)bytesWritten;
}

int readSerialPortUpto(int fh, char *startPtr, int upto)
{
  DWORD totalBytes;
  COMMTIMEOUTS fcommtimeouts;
  void *buffer = (void *)startPtr;

  GetCommTimeouts((HANDLE)fh, &fcommtimeouts);
  fcommtimeouts.ReadIntervalTimeout = 10;
  fcommtimeouts.ReadTotalTimeoutMultiplier = 10;
  fcommtimeouts.ReadTotalTimeoutConstant = 1000;
  SetCommTimeouts((HANDLE)fh, &fcommtimeouts);

  ReadFile((HANDLE)fh, buffer, upto, &totalBytes, NULL);

  fcommtimeouts.ReadIntervalTimeout = MAXDWORD;
  fcommtimeouts.ReadTotalTimeoutMultiplier = 0;
  fcommtimeouts.ReadTotalTimeoutConstant = 0;
  SetCommTimeouts((HANDLE)fh, &fcommtimeouts);

  return (int)totalBytes;
}

void clearInputBuffer(int fd)
{
  char buf;
  while(readSerialPortInto(fd, 1, &buf) == 1)
    ;
}
